/*
 * JBoss, Home of Professional Open Source
 * Copyright 2013, Red Hat, Inc. and/or its affiliates, and individual
 * contributors by the @authors tag. See the copyright.txt in the
 * distribution for a full listing of individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.as.quickstarts.ejbTimer;

import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

import javax.annotation.PostConstruct;
import javax.ejb.Schedule;
import javax.ejb.Singleton;


/**
 * Demonstrates how to use the EJB's @Schedule.
 * 
 * @author <a href="mailto:ozizka@redhat.com">Ondrej Zizka</a>
 */
//@Singleton
public class ScheduleExample {
  
	TCPClient tcpClient;
	int counter;
	
	//@PostConstruct
	void init() {
		System.out.println(this + " Scheduler Example created");
		counter = 0;
		try {
			tcpClient = new TCPClient(new Socket("127.0.0.1", 1235));
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
    //@Schedule(second="*/10", minute="*",hour="*", persistent=false)
    public void doWork(){
        System.out.println(this +  " Hi from the EJB timer example!" );
        tcpClient.exchange("request " + counter++);
    }
    
}